Index: trunk/FACT++/src/drivectrl.cc
===================================================================
--- trunk/FACT++/src/drivectrl.cc	(revision 11053)
+++ trunk/FACT++/src/drivectrl.cc	(revision 11056)
@@ -867,4 +867,5 @@
 }
 
+/*
 template<class S, class T>
 int RunDim(Configuration &conf)
@@ -872,10 +873,4 @@
     WindowLog wout;
 
-    /*
-    static Test shell(conf.GetName().c_str(), conf.Get<int>("console")!=1);
-
-    WindowLog &win  = shell.GetStreamIn();
-    WindowLog &wout = shell.GetStreamOut();
-    */
     ReadlineColor::PrintBootMsg(wout, conf.GetName(), false);
 
@@ -892,22 +887,7 @@
     io_service.Run();
 
-    /*
-    shell.SetReceiver(io_service);
-
-    boost::thread t(boost::bind(RunThread, &io_service));
-    // boost::thread t(boost::bind(&StateMachineDrive<S>::Run, &io_service));
-
-    shell.Run();                 // Run the shell
-    io_service.Stop();           // Signal Loop-thread to stop
-    // io_service.Close();       // Obsolete, done by the destructor
-
-    // Wait until the StateMachine has finished its thread
-    // before returning and destroying the dim objects which might
-    // still be in use.
-    t.join();
-    */
-
     return 0;
 }
+*/
 
 template<class T, class S, class R>
@@ -1061,7 +1041,7 @@
         {
             if (conf.Get<bool>("no-dim"))
-                return RunDim<StateMachine, ConnectionDrive>(conf);
+                return RunShell<LocalStream, StateMachine, ConnectionDrive>(conf);
             else
-                return RunDim<StateMachineDim, ConnectionDimDrive>(conf);
+                return RunShell<LocalStream, StateMachineDim, ConnectionDimDrive>(conf);
         }
         // Cosole access w/ and w/o Dim
Index: trunk/FACT++/src/fadctrl.cc
===================================================================
--- trunk/FACT++/src/fadctrl.cc	(revision 11053)
+++ trunk/FACT++/src/fadctrl.cc	(revision 11056)
@@ -1408,23 +1408,12 @@
 }
 
+/*
 template<class S>
 int RunDim(Configuration &conf)
 {
-    /*
-     initscr();		      // Start curses mode
-     cbreak();		      // Line buffering disabled, Pass on
-     intrflush(stdscr, FALSE);
-     start_color();            // Initialize ncurses colors
-     use_default_colors();     // Assign terminal default colors to -1
-     for (int i=1; i<8; i++)
-        init_pair(i, i, -1);  // -1: def background
-        scrollok(stdscr, true);
-        */
-
     WindowLog wout;
 
     ReadlineColor::PrintBootMsg(wout, conf.GetName(), false);
 
-    //log.SetWindow(stdscr);
     if (conf.Has("log"))
         if (!wout.OpenLogFile(conf.Get<string>("log")))
@@ -1441,4 +1430,5 @@
     return 0;
 }
+*/
 
 template<class T, class S>
@@ -1584,7 +1574,7 @@
         {
             if (conf.Get<bool>("no-dim"))
-                return RunDim<StateMachine>(conf);
+                return RunShell<LocalStream, StateMachine>(conf);
             else
-                return RunDim<StateMachineDim>(conf);
+                return RunShell<LocalStream, StateMachineDim>(conf);
         }
         // Cosole access w/ and w/o Dim
Index: trunk/FACT++/src/ftmctrl.cc
===================================================================
--- trunk/FACT++/src/ftmctrl.cc	(revision 11053)
+++ trunk/FACT++/src/ftmctrl.cc	(revision 11056)
@@ -1777,4 +1777,5 @@
 }
 
+/*
 template<class S, class T>
 int RunDim(Configuration &conf)
@@ -1782,13 +1783,5 @@
     WindowLog wout;
 
-    /*
-    static Test shell(conf.GetName().c_str(), conf.Get<int>("console")!=1);
-
-    WindowLog &win  = shell.GetStreamIn();
-    WindowLog &wout = shell.GetStreamOut();
-    */
-
     ReadlineColor::PrintBootMsg(wout, conf.GetName(), false);
-
 
     if (conf.Has("log"))
@@ -1804,22 +1797,7 @@
     io_service.Run();
 
-    /*
-    shell.SetReceiver(io_service);
-
-    boost::thread t(boost::bind(RunThread, &io_service));
-    // boost::thread t(boost::bind(&StateMachineFTM<S>::Run, &io_service));
-
-    shell.Run();                 // Run the shell
-    io_service.Stop();           // Signal Loop-thread to stop
-    // io_service.Close();       // Obsolete, done by the destructor
-
-    // Wait until the StateMachine has finished its thread
-    // before returning and destroying the dim objects which might
-    // still be in use.
-    t.join();
-    */
-
     return 0;
 }
+*/
 
 template<class T, class S, class R>
@@ -1976,7 +1954,7 @@
         {
             if (conf.Get<bool>("no-dim"))
-                return RunDim<StateMachine, ConnectionFTM>(conf);
+                return RunShell<LocalStream, StateMachine, ConnectionFTM>(conf);
             else
-                return RunDim<StateMachineDim, ConnectionDimFTM>(conf);
+                return RunShell<LocalStream, StateMachineDim, ConnectionDimFTM>(conf);
         }
         // Cosole access w/ and w/o Dim
Index: trunk/FACT++/src/scheduler.cc
===================================================================
--- trunk/FACT++/src/scheduler.cc	(revision 11053)
+++ trunk/FACT++/src/scheduler.cc	(revision 11056)
@@ -738,4 +738,5 @@
 }
 
+/*
 template<class S>
 int RunDim(Configuration &conf)
@@ -760,4 +761,5 @@
     return 0;
 }
+*/
 
 template<class T, class S>
@@ -912,7 +914,7 @@
         {
             if (conf.Get<bool>("no-dim"))
-                return RunDim<StateMachine>(conf);
+                return RunShell<LocalStream, StateMachine>(conf);
             else
-                return RunDim<StateMachineDim>(conf);
+                return RunShell<LocalStream, StateMachineDim>(conf);
         }
         // Cosole access w/ and w/o Dim