Index: trunk/FACT++/src/Connection.cc
===================================================================
--- trunk/FACT++/src/Connection.cc	(revision 11116)
+++ trunk/FACT++/src/Connection.cc	(revision 11118)
@@ -19,6 +19,4 @@
 using boost::lexical_cast;
 using ba::ip::tcp;
-
-#define DEBUG_TX
 
     // -------- Abbreviations for starting async tasks ---------
@@ -177,9 +175,10 @@
     else
     {
-#ifdef DEBUG_TX
-        ostringstream msg;
-        msg << n << " bytes successfully sent to " << URL();
-        Message(msg);
-#endif
+	if (fDebugTx)
+	{
+	    ostringstream msg;
+	    msg << n << " bytes successfully sent to " << URL();
+	    Message(msg);
+	}
     }
 
Index: trunk/FACT++/src/Connection.h
===================================================================
--- trunk/FACT++/src/Connection.h	(revision 11116)
+++ trunk/FACT++/src/Connection.h	(revision 11118)
@@ -17,4 +17,6 @@
     std::string fAddress;
     std::string fPort;
+
+    bool fDebugTx;
 
     enum ConnectionStatus_t
@@ -107,4 +109,6 @@
     bool IsConnecting() const   { return fConnectionStatus==kConnecting;   }
 
+    void SetDebugTx(bool b=true) { fDebugTx=b; }
+
     std::string URL() const { return fAddress + ":" + fPort; }
 };
Index: trunk/FACT++/src/fadctrl.cc
===================================================================
--- trunk/FACT++/src/fadctrl.cc	(revision 11116)
+++ trunk/FACT++/src/fadctrl.cc	(revision 11118)
@@ -574,4 +574,5 @@
     bool fIsHexOutput;
     bool fIsDataOutput;
+    bool fDebugTx;
 
     bool CheckEventSize(size_t has, const char *name, size_t size)
@@ -840,6 +841,17 @@
             return T::kSM_FatalError;
 
-       for (BoardList::iterator i=fBoards.begin(); i!=fBoards.end(); i++)
+        for (BoardList::iterator i=fBoards.begin(); i!=fBoards.end(); i++)
             i->second.second->SetDataOutput(evt.GetBool());
+
+        return T::GetCurrentState();
+    }
+
+    int SetDebugTx(const EventImp &evt)
+    {
+        if (!CheckEventSize(evt.GetSize(), "SetDebugTx", 1))
+            return T::kSM_FatalError;
+
+        for (BoardList::iterator i=fBoards.begin(); i!=fBoards.end(); i++)
+            i->second.second->SetDebugTx(evt.GetBool());
 
         return T::GetCurrentState();
@@ -1083,5 +1095,5 @@
 
         ptr->SetEndpoint(str.str());
-        ptr->StartConnect();
+	ptr->StartConnect();
     }
 
@@ -1269,4 +1281,5 @@
         fBoards[i].second->SetHexOutput(fIsHexOutput);
         fBoards[i].second->SetDataOutput(fIsDataOutput);
+        fBoards[i].second->SetDebugTx(fDebugTx);
     }
 
@@ -1405,10 +1418,10 @@
         T::AddEvent("SET_VERBOSE", "B:1")
             (boost::bind(&StateMachineFAD::SetVerbosity, this, _1))
-            ("set verbosity state"
+            ("Set verbosity state"
              "|verbosity[bool]:disable or enable verbosity for received data (yes/no), except dynamic data");
 
         T::AddEvent("SET_HEX_OUTPUT", "B:1")
             (boost::bind(&StateMachineFAD::SetHexOutput, this, _1))
-            ("enable or disable hex output for received data"
+            ("Enable or disable hex output for received data"
              "|hexout[bool]:disable or enable hex output for received data (yes/no)");
 
@@ -1416,4 +1429,9 @@
             (boost::bind(&StateMachineFAD::SetDataOutput, this, _1))
             ("");
+
+        T::AddEvent("SET_DEBUG_TX", "B:1")
+            (boost::bind(&StateMachineFAD::SetDebugTx, this, _1))
+	    ("Enable or disable the output of messages in case of successfull data transmission to the boards."
+	     "|debug[bool]:disable or enable debug output for transmitted data (yes/no)");
 
         T::AddEvent("PRINT_EVENT", "S:1")
@@ -1543,4 +1561,5 @@
         fIsHexOutput = conf.Get<bool>("hex-out");
         fIsDataOutput = conf.Get<bool>("data-out");
+        fDebugTx = conf.Get<bool>("debug-tx");
 
         SetMaxMemory(conf.Get<unsigned int>("max-mem"));
@@ -1712,4 +1731,5 @@
         ("hex-out",    po_bool(),  "Enable printing contents of all printed messages also as hex data.")
         ("data-out",   po_bool(),  "Enable printing received event data.")
+        ("debug-tx",   po_bool(),  "Enable debugging of ethernet transmission.")
         ;
 