Index: trunk/FACT++/gui/design.ui
===================================================================
--- trunk/FACT++/gui/design.ui	(revision 11119)
+++ trunk/FACT++/gui/design.ui	(revision 11124)
@@ -37,5 +37,5 @@
      <enum>QLayout::SetDefaultConstraint</enum>
     </property>
-    <item row="1" column="0">
+    <item row="0" column="0">
      <widget class="QTabWidget" name="fTabWidget">
       <property name="enabled">
@@ -2874,5 +2874,5 @@
             <property name="geometry">
              <rect>
-              <x>570</x>
+              <x>530</x>
               <y>10</y>
               <width>307</width>
@@ -3080,7 +3080,7 @@
             <property name="geometry">
              <rect>
-              <x>630</x>
-              <y>220</y>
-              <width>261</width>
+              <x>540</x>
+              <y>230</y>
+              <width>281</width>
               <height>284</height>
              </rect>
@@ -3998,5 +3998,5 @@
             <property name="geometry">
              <rect>
-              <x>310</x>
+              <x>300</x>
               <y>30</y>
               <width>221</width>
@@ -4299,5 +4299,5 @@
             <property name="geometry">
              <rect>
-              <x>370</x>
+              <x>300</x>
               <y>10</y>
               <width>121</width>
@@ -4314,5 +4314,5 @@
               <x>0</x>
               <y>410</y>
-              <width>231</width>
+              <width>181</width>
               <height>101</height>
              </rect>
@@ -4335,6 +4335,6 @@
             <property name="geometry">
              <rect>
-              <x>320</x>
-              <y>210</y>
+              <x>300</x>
+              <y>280</y>
               <width>209</width>
               <height>104</height>
@@ -4460,6 +4460,6 @@
             <property name="geometry">
              <rect>
-              <x>320</x>
-              <y>190</y>
+              <x>300</x>
+              <y>260</y>
               <width>191</width>
               <height>16</height>
@@ -4473,6 +4473,6 @@
             <property name="geometry">
              <rect>
-              <x>280</x>
-              <y>380</y>
+              <x>190</x>
+              <y>390</y>
               <width>341</width>
               <height>125</height>
@@ -4601,6 +4601,6 @@
             <property name="geometry">
              <rect>
-              <x>290</x>
-              <y>360</y>
+              <x>190</x>
+              <y>370</y>
               <width>91</width>
               <height>16</height>
@@ -4614,6 +4614,6 @@
             <property name="geometry">
              <rect>
-              <x>680</x>
-              <y>190</y>
+              <x>630</x>
+              <y>200</y>
               <width>94</width>
               <height>24</height>
@@ -4627,5 +4627,5 @@
             <property name="geometry">
              <rect>
-              <x>580</x>
+              <x>530</x>
               <y>170</y>
               <width>94</width>
@@ -4640,5 +4640,5 @@
             <property name="geometry">
              <rect>
-              <x>680</x>
+              <x>630</x>
               <y>170</y>
               <width>94</width>
@@ -4653,5 +4653,5 @@
             <property name="geometry">
              <rect>
-              <x>780</x>
+              <x>730</x>
               <y>170</y>
               <width>94</width>
@@ -4661,4 +4661,61 @@
             <property name="text">
              <string>Abort</string>
+            </property>
+           </widget>
+           <widget class="QLabel" name="label_138">
+            <property name="geometry">
+             <rect>
+              <x>300</x>
+              <y>180</y>
+              <width>161</width>
+              <height>16</height>
+             </rect>
+            </property>
+            <property name="text">
+             <string>EventBuilderThread running</string>
+            </property>
+           </widget>
+           <widget class="QPushButton" name="fFadLEDEventBuilder">
+            <property name="enabled">
+             <bool>true</bool>
+            </property>
+            <property name="geometry">
+             <rect>
+              <x>470</x>
+              <y>180</y>
+              <width>18</width>
+              <height>25</height>
+             </rect>
+            </property>
+            <property name="sizePolicy">
+             <sizepolicy hsizetype="Fixed" vsizetype="Minimum">
+              <horstretch>0</horstretch>
+              <verstretch>0</verstretch>
+             </sizepolicy>
+            </property>
+            <property name="maximumSize">
+             <size>
+              <width>18</width>
+              <height>16777215</height>
+             </size>
+            </property>
+            <property name="text">
+             <string/>
+            </property>
+            <property name="icon">
+             <iconset resource="design.qrc">
+              <normaloff>:/Resources/icons/gray circle 1.png</normaloff>:/Resources/icons/gray circle 1.png</iconset>
+            </property>
+            <property name="iconSize">
+             <size>
+              <width>16</width>
+              <height>16</height>
+             </size>
+            </property>
+            <property name="checkable">
+             <bool>false</bool>
+            </property>
+            <property name="flat">
+             <bool>true</bool>
             </property>
            </widget>
@@ -4672,40 +4729,62 @@
         <string>ADC</string>
        </attribute>
-       <widget class="QFrame" name="frame_5">
-        <property name="geometry">
-         <rect>
-          <x>40</x>
-          <y>20</y>
-          <width>711</width>
-          <height>506</height>
-         </rect>
-        </property>
-        <property name="sizePolicy">
-         <sizepolicy hsizetype="Expanding" vsizetype="Preferred">
-          <horstretch>0</horstretch>
-          <verstretch>0</verstretch>
-         </sizepolicy>
-        </property>
-        <property name="minimumSize">
-         <size>
-          <width>500</width>
-          <height>500</height>
-         </size>
-        </property>
-        <property name="frameShape">
-         <enum>QFrame::StyledPanel</enum>
-        </property>
-        <property name="frameShadow">
-         <enum>QFrame::Sunken</enum>
-        </property>
-        <layout class="QGridLayout" name="gridLayout_44">
-         <property name="margin">
-          <number>3</number>
-         </property>
-         <item row="0" column="0">
-          <widget class="RootWidget" name="fAdcDataCanv" native="true"/>
-         </item>
-        </layout>
-       </widget>
+       <layout class="QGridLayout" name="gridLayout_46">
+        <item row="0" column="0">
+         <widget class="QDockWidget" name="fAdcDock">
+          <property name="sizePolicy">
+           <sizepolicy hsizetype="Expanding" vsizetype="Expanding">
+            <horstretch>0</horstretch>
+            <verstretch>0</verstretch>
+           </sizepolicy>
+          </property>
+          <property name="features">
+           <set>QDockWidget::NoDockWidgetFeatures</set>
+          </property>
+          <property name="windowTitle">
+           <string>Display of ADC data</string>
+          </property>
+          <widget class="QWidget" name="fAdcWidget">
+           <property name="sizePolicy">
+            <sizepolicy hsizetype="Expanding" vsizetype="Expanding">
+             <horstretch>0</horstretch>
+             <verstretch>0</verstretch>
+            </sizepolicy>
+           </property>
+           <layout class="QGridLayout" name="gridLayout_45">
+            <item row="0" column="0">
+             <widget class="QFrame" name="frame_5">
+              <property name="sizePolicy">
+               <sizepolicy hsizetype="Expanding" vsizetype="Preferred">
+                <horstretch>0</horstretch>
+                <verstretch>0</verstretch>
+               </sizepolicy>
+              </property>
+              <property name="minimumSize">
+               <size>
+                <width>500</width>
+                <height>500</height>
+               </size>
+              </property>
+              <property name="frameShape">
+               <enum>QFrame::StyledPanel</enum>
+              </property>
+              <property name="frameShadow">
+               <enum>QFrame::Sunken</enum>
+              </property>
+              <layout class="QGridLayout" name="gridLayout_44">
+               <property name="margin">
+                <number>3</number>
+               </property>
+               <item row="0" column="0">
+                <widget class="RootWidget" name="fAdcDataCanv" native="true"/>
+               </item>
+              </layout>
+             </widget>
+            </item>
+           </layout>
+          </widget>
+         </widget>
+        </item>
+       </layout>
       </widget>
       <widget class="QWidget" name="fLoggerTab">
@@ -5054,4 +5133,16 @@
                <enum>QAbstractSpinBox::NoButtons</enum>
               </property>
+              <property name="currentSection">
+               <enum>QDateTimeEdit::HourSection</enum>
+              </property>
+              <property name="displayFormat">
+               <string>hh:mm:ss</string>
+              </property>
+              <property name="calendarPopup">
+               <bool>false</bool>
+              </property>
+              <property name="timeSpec">
+               <enum>Qt::OffsetFromUTC</enum>
+              </property>
               <property name="time">
                <time>
@@ -5060,16 +5151,4 @@
                 <second>0</second>
                </time>
-              </property>
-              <property name="currentSection">
-               <enum>QDateTimeEdit::HourSection</enum>
-              </property>
-              <property name="displayFormat">
-               <string>hh:mm:ss</string>
-              </property>
-              <property name="calendarPopup">
-               <bool>false</bool>
-              </property>
-              <property name="timeSpec">
-               <enum>Qt::OffsetFromUTC</enum>
               </property>
              </widget>
@@ -5196,4 +5275,16 @@
                <enum>QAbstractSpinBox::NoButtons</enum>
               </property>
+              <property name="currentSection">
+               <enum>QDateTimeEdit::HourSection</enum>
+              </property>
+              <property name="displayFormat">
+               <string>hh:mm:ss</string>
+              </property>
+              <property name="calendarPopup">
+               <bool>false</bool>
+              </property>
+              <property name="timeSpec">
+               <enum>Qt::OffsetFromUTC</enum>
+              </property>
               <property name="time">
                <time>
@@ -5202,16 +5293,4 @@
                 <second>0</second>
                </time>
-              </property>
-              <property name="currentSection">
-               <enum>QDateTimeEdit::HourSection</enum>
-              </property>
-              <property name="displayFormat">
-               <string>hh:mm:ss</string>
-              </property>
-              <property name="calendarPopup">
-               <bool>false</bool>
-              </property>
-              <property name="timeSpec">
-               <enum>Qt::OffsetFromUTC</enum>
               </property>
              </widget>