Index: trunk/FACT++/gui/design.ui
===================================================================
--- trunk/FACT++/gui/design.ui	(revision 11138)
+++ trunk/FACT++/gui/design.ui	(revision 11141)
@@ -3088,5 +3088,5 @@
             <layout class="QGridLayout" name="gridLayout_37">
              <item row="1" column="0">
-              <widget class="QPushButton" name="fFadLedPllLck">
+              <widget class="QPushButton" name="fFadLedDenable">
                <property name="enabled">
                 <bool>true</bool>
@@ -3126,5 +3126,5 @@
              </item>
              <item row="2" column="0">
-              <widget class="QPushButton" name="fFadLedDenable">
+              <widget class="QPushButton" name="fFadLedDwrite">
                <property name="enabled">
                 <bool>true</bool>
@@ -3164,5 +3164,5 @@
              </item>
              <item row="3" column="0">
-              <widget class="QPushButton" name="fFadLedDwrite">
+              <widget class="QPushButton" name="fFadLedDcmLocked">
                <property name="enabled">
                 <bool>true</bool>
@@ -3202,5 +3202,5 @@
              </item>
              <item row="4" column="0">
-              <widget class="QPushButton" name="fFadLedDcmLocked">
+              <widget class="QPushButton" name="fFadLedDcmReady">
                <property name="enabled">
                 <bool>true</bool>
@@ -3240,5 +3240,5 @@
              </item>
              <item row="5" column="0">
-              <widget class="QPushButton" name="fFadLedDcmReady">
+              <widget class="QPushButton" name="fFadLedSpiSclk">
                <property name="enabled">
                 <bool>true</bool>
@@ -3277,50 +3277,5 @@
               </widget>
              </item>
-             <item row="6" column="0">
-              <widget class="QPushButton" name="fFadLedSpiSclk">
-               <property name="enabled">
-                <bool>true</bool>
-               </property>
-               <property name="sizePolicy">
-                <sizepolicy hsizetype="Fixed" vsizetype="Minimum">
-                 <horstretch>0</horstretch>
-                 <verstretch>0</verstretch>
-                </sizepolicy>
-               </property>
-               <property name="maximumSize">
-                <size>
-                 <width>18</width>
-                 <height>16777215</height>
-                </size>
-               </property>
-               <property name="text">
-                <string/>
-               </property>
-               <property name="icon">
-                <iconset resource="design.qrc">
-                 <normaloff>:/Resources/icons/gray circle 1.png</normaloff>:/Resources/icons/gray circle 1.png</iconset>
-               </property>
-               <property name="iconSize">
-                <size>
-                 <width>16</width>
-                 <height>16</height>
-                </size>
-               </property>
-               <property name="checkable">
-                <bool>false</bool>
-               </property>
-               <property name="flat">
-                <bool>true</bool>
-               </property>
-              </widget>
-             </item>
              <item row="1" column="3">
-              <widget class="QLabel" name="label_92">
-               <property name="text">
-                <string>PLL lock</string>
-               </property>
-              </widget>
-             </item>
-             <item row="2" column="3">
               <widget class="QLabel" name="label_93">
                <property name="text">
@@ -3329,5 +3284,5 @@
               </widget>
              </item>
-             <item row="3" column="3">
+             <item row="2" column="3">
               <widget class="QLabel" name="label_94">
                <property name="text">
@@ -3336,5 +3291,5 @@
               </widget>
              </item>
-             <item row="4" column="3">
+             <item row="3" column="3">
               <widget class="QLabel" name="label_95">
                <property name="text">
@@ -3343,5 +3298,5 @@
               </widget>
              </item>
-             <item row="5" column="3">
+             <item row="4" column="3">
               <widget class="QLabel" name="label_96">
                <property name="text">
@@ -3350,5 +3305,5 @@
               </widget>
              </item>
-             <item row="6" column="3">
+             <item row="5" column="3">
               <widget class="QLabel" name="label_97">
                <property name="text">
@@ -3358,18 +3313,4 @@
              </item>
              <item row="1" column="1">
-              <widget class="QPushButton" name="fFadPllLockOn">
-               <property name="text">
-                <string>on</string>
-               </property>
-              </widget>
-             </item>
-             <item row="1" column="2">
-              <widget class="QPushButton" name="fFadPllLockOff">
-               <property name="text">
-                <string>off</string>
-               </property>
-              </widget>
-             </item>
-             <item row="2" column="1">
               <widget class="QPushButton" name="fFadDrsOn">
                <property name="text">
@@ -3378,5 +3319,5 @@
               </widget>
              </item>
-             <item row="3" column="1">
+             <item row="2" column="1">
               <widget class="QPushButton" name="fFadDwriteOn">
                <property name="text">
@@ -3385,5 +3326,5 @@
               </widget>
              </item>
-             <item row="4" column="1">
+             <item row="3" column="1">
               <widget class="QPushButton" name="pushButton_8">
                <property name="text">
@@ -3392,5 +3333,5 @@
               </widget>
              </item>
-             <item row="5" column="1">
+             <item row="4" column="1">
               <widget class="QPushButton" name="pushButton_9">
                <property name="text">
@@ -3399,5 +3340,5 @@
               </widget>
              </item>
-             <item row="6" column="1">
+             <item row="5" column="1">
               <widget class="QPushButton" name="pushButton_10">
                <property name="text">
@@ -3406,5 +3347,5 @@
               </widget>
              </item>
-             <item row="2" column="2">
+             <item row="1" column="2">
               <widget class="QPushButton" name="fFadDrsOff">
                <property name="text">
@@ -3413,5 +3354,5 @@
               </widget>
              </item>
-             <item row="3" column="2">
+             <item row="2" column="2">
               <widget class="QPushButton" name="fFadDwriteOff">
                <property name="text">
@@ -3420,5 +3361,5 @@
               </widget>
              </item>
-             <item row="4" column="2">
+             <item row="3" column="2">
               <widget class="QPushButton" name="pushButton_13">
                <property name="text">
@@ -3427,5 +3368,5 @@
               </widget>
              </item>
-             <item row="5" column="2">
+             <item row="4" column="2">
               <widget class="QPushButton" name="pushButton_14">
                <property name="text">
@@ -3434,5 +3375,5 @@
               </widget>
              </item>
-             <item row="6" column="2">
+             <item row="5" column="2">
               <widget class="QPushButton" name="pushButton_15">
                <property name="text">
@@ -3455,5 +3396,5 @@
               </widget>
              </item>
-             <item row="7" column="2">
+             <item row="6" column="2">
               <widget class="QPushButton" name="fFadTriggerLineOff">
                <property name="text">
@@ -3462,5 +3403,5 @@
               </widget>
              </item>
-             <item row="7" column="3">
+             <item row="6" column="3">
               <widget class="QLabel" name="label_134">
                <property name="text">
@@ -3469,5 +3410,5 @@
               </widget>
              </item>
-             <item row="8" column="3">
+             <item row="7" column="3">
               <widget class="QLabel" name="label_106">
                <property name="text">
@@ -3476,5 +3417,5 @@
               </widget>
              </item>
-             <item row="7" column="1">
+             <item row="6" column="1">
               <widget class="QPushButton" name="fFadTriggerLineOn">
                <property name="text">
@@ -3483,5 +3424,5 @@
               </widget>
              </item>
-             <item row="8" column="1">
+             <item row="7" column="1">
               <widget class="QPushButton" name="fFadContTriggerOn">
                <property name="text">
@@ -3490,5 +3431,5 @@
               </widget>
              </item>
-             <item row="8" column="2">
+             <item row="7" column="2">
               <widget class="QPushButton" name="fFadContTriggerOff">
                <property name="text">
@@ -3504,5 +3445,5 @@
               </widget>
              </item>
-             <item row="9" column="3">
+             <item row="8" column="3">
               <widget class="QLabel" name="label_137">
                <property name="text">
@@ -3511,5 +3452,5 @@
               </widget>
              </item>
-             <item row="9" column="1">
+             <item row="8" column="1">
               <widget class="QPushButton" name="fFadSocket0">
                <property name="text">
@@ -3518,5 +3459,5 @@
               </widget>
              </item>
-             <item row="9" column="2">
+             <item row="8" column="2">
               <widget class="QPushButton" name="fFadSocket17">
                <property name="text">
@@ -3533,5 +3474,5 @@
               <y>20</y>
               <width>281</width>
-              <height>234</height>
+              <height>263</height>
              </rect>
             </property>
@@ -3886,5 +3827,5 @@
               </widget>
              </item>
-             <item row="8" column="0">
+             <item row="9" column="0">
               <widget class="QLabel" name="label_111">
                <property name="text">
@@ -3893,5 +3834,5 @@
               </widget>
              </item>
-             <item row="8" column="1">
+             <item row="9" column="1">
               <widget class="QPushButton" name="fStatusDNSLed_10">
                <property name="enabled">
@@ -3931,5 +3872,5 @@
               </widget>
              </item>
-             <item row="8" column="2">
+             <item row="9" column="2">
               <widget class="QDoubleSpinBox" name="doubleSpinBox_2">
                <property name="alignment">
@@ -3944,5 +3885,5 @@
               </widget>
              </item>
-             <item row="8" column="3">
+             <item row="9" column="3">
               <widget class="QDoubleSpinBox" name="doubleSpinBox_3">
                <property name="alignment">
@@ -3957,5 +3898,5 @@
               </widget>
              </item>
-             <item row="7" column="2">
+             <item row="8" column="2">
               <widget class="QLabel" name="label_128">
                <property name="text">
@@ -3967,5 +3908,5 @@
               </widget>
              </item>
-             <item row="7" column="3">
+             <item row="8" column="3">
               <widget class="QLabel" name="label_129">
                <property name="text">
@@ -3977,5 +3918,5 @@
               </widget>
              </item>
-             <item row="6" column="1">
+             <item row="7" column="1">
               <spacer name="verticalSpacer_26">
                <property name="orientation">
@@ -3992,4 +3933,49 @@
                </property>
               </spacer>
+             </item>
+             <item row="6" column="0">
+              <widget class="QLabel" name="label_92">
+               <property name="text">
+                <string>PLL lock</string>
+               </property>
+              </widget>
+             </item>
+             <item row="6" column="1">
+              <widget class="QPushButton" name="fFadLedPllLck">
+               <property name="enabled">
+                <bool>true</bool>
+               </property>
+               <property name="sizePolicy">
+                <sizepolicy hsizetype="Fixed" vsizetype="Minimum">
+                 <horstretch>0</horstretch>
+                 <verstretch>0</verstretch>
+                </sizepolicy>
+               </property>
+               <property name="maximumSize">
+                <size>
+                 <width>18</width>
+                 <height>16777215</height>
+                </size>
+               </property>
+               <property name="text">
+                <string/>
+               </property>
+               <property name="icon">
+                <iconset resource="design.qrc">
+                 <normaloff>:/Resources/icons/gray circle 1.png</normaloff>:/Resources/icons/gray circle 1.png</iconset>
+               </property>
+               <property name="iconSize">
+                <size>
+                 <width>16</width>
+                 <height>16</height>
+                </size>
+               </property>
+               <property name="checkable">
+                <bool>false</bool>
+               </property>
+               <property name="flat">
+                <bool>true</bool>
+               </property>
+              </widget>
              </item>
             </layout>
@@ -4324,8 +4310,8 @@
             <property name="geometry">
              <rect>
-              <x>100</x>
-              <y>260</y>
+              <x>10</x>
+              <y>310</y>
               <width>181</width>
-              <height>101</height>
+              <height>51</height>
              </rect>
             </property>
@@ -4334,6 +4320,6 @@
             <property name="geometry">
              <rect>
-              <x>30</x>
-              <y>270</y>
+              <x>20</x>
+              <y>290</y>
               <width>57</width>
               <height>15</height>