Index: trunk/FACT++/gui/design.ui
===================================================================
--- trunk/FACT++/gui/design.ui	(revision 11143)
+++ trunk/FACT++/gui/design.ui	(revision 11158)
@@ -3080,5 +3080,5 @@
             <property name="geometry">
              <rect>
-              <x>540</x>
+              <x>600</x>
               <y>230</y>
               <width>281</width>
@@ -3987,5 +3987,5 @@
               <y>30</y>
               <width>253</width>
-              <height>140</height>
+              <height>141</height>
              </rect>
             </property>
@@ -4174,20 +4174,4 @@
               </widget>
              </item>
-             <item row="2" column="3">
-              <widget class="QSpinBox" name="fEvtsTriggerId">
-               <property name="alignment">
-                <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-               </property>
-               <property name="readOnly">
-                <bool>true</bool>
-               </property>
-               <property name="buttonSymbols">
-                <enum>QAbstractSpinBox::NoButtons</enum>
-               </property>
-               <property name="maximum">
-                <number>1000000</number>
-               </property>
-              </widget>
-             </item>
              <item row="3" column="2">
               <widget class="QSpinBox" name="spinBox_8">
@@ -4204,5 +4188,5 @@
              </item>
              <item row="3" column="3">
-              <widget class="QSpinBox" name="spinBox_9">
+              <widget class="QSpinBox" name="fEvtsEventId">
                <property name="alignment">
                 <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
@@ -4276,4 +4260,20 @@
                <property name="text">
                 <string>Max</string>
+               </property>
+              </widget>
+             </item>
+             <item row="2" column="3">
+              <widget class="QSpinBox" name="fEvtsTriggerId">
+               <property name="alignment">
+                <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+               </property>
+               <property name="readOnly">
+                <bool>true</bool>
+               </property>
+               <property name="buttonSymbols">
+                <enum>QAbstractSpinBox::NoButtons</enum>
+               </property>
+               <property name="maximum">
+                <number>1000000</number>
                </property>
               </widget>
@@ -4333,6 +4333,6 @@
             <property name="geometry">
              <rect>
-              <x>300</x>
-              <y>230</y>
+              <x>360</x>
+              <y>390</y>
               <width>227</width>
               <height>104</height>
@@ -4464,6 +4464,6 @@
             <property name="geometry">
              <rect>
-              <x>300</x>
-              <y>210</y>
+              <x>380</x>
+              <y>370</y>
               <width>191</width>
               <height>16</height>
@@ -4491,17 +4491,4 @@
               </widget>
              </item>
-             <item row="2" column="3">
-              <widget class="QDoubleSpinBox" name="doubleSpinBox_7">
-               <property name="alignment">
-                <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-               </property>
-               <property name="readOnly">
-                <bool>true</bool>
-               </property>
-               <property name="buttonSymbols">
-                <enum>QAbstractSpinBox::NoButtons</enum>
-               </property>
-              </widget>
-             </item>
              <item row="2" column="2">
               <widget class="QDoubleSpinBox" name="doubleSpinBox_4">
@@ -4613,4 +4600,23 @@
                <property name="suffix">
                 <string> MB</string>
+               </property>
+               <property name="maximum">
+                <number>1000000</number>
+               </property>
+              </widget>
+             </item>
+             <item row="2" column="3">
+              <widget class="QSpinBox" name="fFadEvtRead">
+               <property name="alignment">
+                <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+               </property>
+               <property name="readOnly">
+                <bool>true</bool>
+               </property>
+               <property name="buttonSymbols">
+                <enum>QAbstractSpinBox::NoButtons</enum>
+               </property>
+               <property name="suffix">
+                <string> kB/s</string>
                </property>
                <property name="maximum">
@@ -4689,5 +4695,5 @@
             <property name="geometry">
              <rect>
-              <x>300</x>
+              <x>370</x>
               <y>180</y>
               <width>161</width>
@@ -4705,6 +4711,6 @@
             <property name="geometry">
              <rect>
-              <x>470</x>
-              <y>180</y>
+              <x>540</x>
+              <y>170</y>
               <width>18</width>
               <height>25</height>
@@ -4746,7 +4752,7 @@
             <property name="geometry">
              <rect>
-              <x>389</x>
-              <y>350</y>
-              <width>131</width>
+              <x>300</x>
+              <y>200</y>
+              <width>284</width>
               <height>160</height>
              </rect>
@@ -4756,5 +4762,5 @@
               <widget class="QLabel" name="label_140">
                <property name="text">
-                <string>Wait</string>
+                <string>Evts waiting for completion</string>
                </property>
               </widget>
@@ -4763,5 +4769,5 @@
               <widget class="QLabel" name="label_139">
                <property name="text">
-                <string>Skip</string>
+                <string>Incomplete evts ready</string>
                </property>
               </widget>
@@ -4770,5 +4776,5 @@
               <widget class="QLabel" name="label_141">
                <property name="text">
-                <string>Del</string>
+                <string>Incompl evts rem f buf (last s)</string>
                </property>
               </widget>
@@ -4777,19 +4783,12 @@
               <widget class="QLabel" name="label_142">
                <property name="text">
-                <string>Tot</string>
+                <string>Incompl evts rem f buffer (tot)</string>
                </property>
               </widget>
              </item>
              <item row="4" column="0">
-              <widget class="QLabel" name="label_143">
-               <property name="text">
-                <string>Read</string>
-               </property>
-              </widget>
-             </item>
-             <item row="5" column="0">
               <widget class="QLabel" name="label_144">
                <property name="text">
-                <string>Conn</string>
+                <string>Connections</string>
                </property>
               </widget>
@@ -4860,20 +4859,4 @@
              </item>
              <item row="4" column="1">
-              <widget class="QSpinBox" name="fFadEvtRead">
-               <property name="alignment">
-                <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
-               </property>
-               <property name="readOnly">
-                <bool>true</bool>
-               </property>
-               <property name="buttonSymbols">
-                <enum>QAbstractSpinBox::NoButtons</enum>
-               </property>
-               <property name="maximum">
-                <number>10000000</number>
-               </property>
-              </widget>
-             </item>
-             <item row="5" column="1">
               <widget class="QSpinBox" name="fFadEvtConn">
                <property name="alignment">