Index: trunk/FACT++/gui/design.ui
===================================================================
--- trunk/FACT++/gui/design.ui	(revision 11214)
+++ trunk/FACT++/gui/design.ui	(revision 11222)
@@ -4600,5 +4600,5 @@
                   </rect>
                  </property>
-                 <layout class="QGridLayout" name="gridLayout_48" columnstretch="0,0,0,0,0,0">
+                 <layout class="QGridLayout" name="gridLayout_48" columnstretch="0,0,0,0,0">
                   <item row="4" column="3">
                    <widget class="QDoubleSpinBox" name="fFadEthernetRateAvg">
@@ -5508,16 +5508,4 @@
                <enum>QAbstractSpinBox::NoButtons</enum>
               </property>
-              <property name="currentSection">
-               <enum>QDateTimeEdit::HourSection</enum>
-              </property>
-              <property name="displayFormat">
-               <string>hh:mm:ss</string>
-              </property>
-              <property name="calendarPopup">
-               <bool>false</bool>
-              </property>
-              <property name="timeSpec">
-               <enum>Qt::OffsetFromUTC</enum>
-              </property>
               <property name="time">
                <time>
@@ -5526,4 +5514,16 @@
                 <second>0</second>
                </time>
+              </property>
+              <property name="currentSection">
+               <enum>QDateTimeEdit::HourSection</enum>
+              </property>
+              <property name="displayFormat">
+               <string>hh:mm:ss</string>
+              </property>
+              <property name="calendarPopup">
+               <bool>false</bool>
+              </property>
+              <property name="timeSpec">
+               <enum>Qt::OffsetFromUTC</enum>
               </property>
              </widget>
@@ -5650,16 +5650,4 @@
                <enum>QAbstractSpinBox::NoButtons</enum>
               </property>
-              <property name="currentSection">
-               <enum>QDateTimeEdit::HourSection</enum>
-              </property>
-              <property name="displayFormat">
-               <string>hh:mm:ss</string>
-              </property>
-              <property name="calendarPopup">
-               <bool>false</bool>
-              </property>
-              <property name="timeSpec">
-               <enum>Qt::OffsetFromUTC</enum>
-              </property>
               <property name="time">
                <time>
@@ -5668,4 +5656,16 @@
                 <second>0</second>
                </time>
+              </property>
+              <property name="currentSection">
+               <enum>QDateTimeEdit::HourSection</enum>
+              </property>
+              <property name="displayFormat">
+               <string>hh:mm:ss</string>
+              </property>
+              <property name="calendarPopup">
+               <bool>false</bool>
+              </property>
+              <property name="timeSpec">
+               <enum>Qt::OffsetFromUTC</enum>
               </property>
              </widget>
@@ -6984,5 +6984,5 @@
     <size>
      <width>230</width>
-     <height>403</height>
+     <height>431</height>
     </size>
    </property>
@@ -7605,4 +7605,38 @@
      <item>
       <spacer name="verticalSpacer_3">
+       <property name="orientation">
+        <enum>Qt::Vertical</enum>
+       </property>
+       <property name="sizeHint" stdset="0">
+        <size>
+         <width>20</width>
+         <height>40</height>
+        </size>
+       </property>
+      </spacer>
+     </item>
+     <item>
+      <layout class="QHBoxLayout" name="horizontalLayout_25">
+       <property name="topMargin">
+        <number>0</number>
+       </property>
+       <item>
+        <widget class="QPushButton" name="fFtmStartRun">
+         <property name="text">
+          <string>Start run</string>
+         </property>
+        </widget>
+       </item>
+       <item>
+        <widget class="QPushButton" name="fFtmStopRun">
+         <property name="text">
+          <string>Stop run</string>
+         </property>
+        </widget>
+       </item>
+      </layout>
+     </item>
+     <item>
+      <spacer name="verticalSpacer_31">
        <property name="orientation">
         <enum>Qt::Vertical</enum>