Index: trunk/FACT++/src/argv.cc
===================================================================
--- trunk/FACT++/src/argv.cc	(revision 11228)
+++ trunk/FACT++/src/argv.cc	(revision 11229)
@@ -4,36 +4,4 @@
 
 using namespace std;
-
-template<class T,class S>
-std::ostream &operator<<(std::ostream &out, const pair<T,S> &f)
-{
-    out << f.first << "|" << f.second;
-    return out;
-}
-template<class T, class S>
-std::istream &operator>>(std::istream &in,  pair<T,S> &f)
-{
-    char c;
-    in >> f.first;
-    in >> c;
-    if (c!=':')
-        return in;
-    in >> f.second;
-    return in;
-}
-
-typedef pair<int,int> mytype;
-
-
-//Source is OutputStreamable, meaning that an operator<< is defined
-// that takes a std::ostream or std::wostream object on the left hand side
-// and an instance of the argument type on the right.
-
-// Target is InputStreamable, meaning that an operator>> is defined that
-// takes a std::istream or std::wistream object on the left hand side and
-// an instance of the result type on the right.
-
-//Target is CopyConstructible [20.1.3].
-//Target is DefaultConstructible, meaning that it is possible to default-initialize an object of that type [8.5, 20.1.4].
 
 // --------------------------------------------------------------------------
@@ -114,5 +82,4 @@
         ("switch",        po_switch(),                    "include path")
         ("bool",          var<bool>()->implicit_value(true),                    "include path")
-        ("mytype",        var<mytype>(),                  "include path")
         ;
 
@@ -205,5 +172,4 @@
     cout << conf.Has("switch") << " " << conf.Get<bool>("switch") << endl;
     cout << conf.Has("bool") << " " << conf.Get<bool>("bool") << endl;
-    cout << conf.Has("mytype") << " " << conf.Get<mytype>("mytype") << endl;
 
     return 0;
Index: trunk/FACT++/src/logtime.cc
===================================================================
--- trunk/FACT++/src/logtime.cc	(revision 11228)
+++ trunk/FACT++/src/logtime.cc	(revision 11229)
@@ -6,9 +6,7 @@
 #include <iostream>
 
-#include "DimDescriptionService.h"
-
 int main(int, const char **)
 {
-    // We could use putenv to make the Configure class change the value...
+   // We could use putenv to make the Configure class change the value...
     setenv("DIM_DNS_NODE", "localhost", 0);
 
@@ -16,32 +14,6 @@
     DimServer::start("TIME");
 
-    usleep(2000000);
-
-    DimServer::stop();
-
-    return 0;
-
     // Some info on the console
     std::cout << "Offering TIME/MESSAGE...\n" << std::endl;
-
-    short s;
-    int i;
-    long long ll;
-    float f;
-    DimDescribedService servt("TIME/TEST", "O:1;I:1;C",
-                              "This is my test command|Char[c]:This is a char|   Int This is an int|String[s]:This is a string");
-
-    DimDescribedService servs("TIME/SHORT",     s,  "[a]");
-    DimDescribedService servx("TIME/LONGLONG",  ll, "|: This is my long long");
-    DimDescribedService servi("TIME/INT",       i,  "|MyInt  [  mi  ] ");
-    DimDescribedService servf("TIME/FLOAT",     f,  "|   MyFloat  :   This is my float");
-    DimDescribedService servc("TIME/TIME", const_cast<char*>(""), "|MyTime[T]:This is my time");
-
-    DimCommand cmd("TIME/CMD", "I:2;F:2");
-
-    DimDescriptionService des("TIME/CMD", "|range[addr]:From DAC to DAC|values[DAC]:DAC values to be set");
-
-    {
-    Time t0;
 
     // Setup a DimService called TIME/MESSAGE
@@ -51,21 +23,8 @@
         // Send current time
         msg.Message(Time().GetAsStr());
-//        servx.Update();
-        /*
-        servs.updateService();
-        servi.updateService();
-        servf.updateService();
-        servc.updateService();
-         */
+
         // wait approximately one second
-        usleep(100000);
-
-//        if (t0.UnixTime()-Time().UnixTime()<-5)
-//            break;
+        usleep(1000000);
     }
-    }
-
-    DimDescribedService servxx("TIME/XXX", const_cast<char*>(""), "|MyTime[T]:This is my time");
-    usleep(10000000);
 
     return 0;
Index: trunk/FACT++/src/tools.cc
===================================================================
--- trunk/FACT++/src/tools.cc	(revision 11228)
+++ trunk/FACT++/src/tools.cc	(revision 11229)
@@ -12,8 +12,6 @@
 #include <stdarg.h>
 
-#include <boost/filesystem.hpp>
+using namespace std;
 
-using namespace std;
-/*
 string Tools::Format(const char *fmt, va_list &ap)
 {
@@ -51,5 +49,4 @@
     return str;
 }
-*/
 
 // --------------------------------------------------------------------------
@@ -57,5 +54,5 @@
 //! This is a static helper to remove leading and trailing whitespaces.
 //!
-//! @param str
+//! @param buf
 //!    a pointer to the char array from which the whitespaces should be
 //!    removed
@@ -76,47 +73,2 @@
     return str.substr(start, end-start+1);
 }
-
-// --------------------------------------------------------------------------
-//
-//! Splits a string of the form [SERVER/]COMMAND[ arguments]
-//! into SERVER, COMMAND and arguments.
-//!
-//! @param str
-//!    string to be splitted
-//!
-//! @returns
-//!    a vector<string> with three components. Depending on what is existing
-//!    in the string some of the components might be empty.
-//!
-/*
-vector<string> Split(std::string str)
-{
-    const size_t p0 = str.find_first_of('/');
-
-    size_t p1 = str.find_first_of(' ');
-
-    vector<string> v(3);
-
-    // string starts with SERVER/COMMAND[ arguments]
-    if (p0<p1)
-    {
-        // SERVER
-        v[0] = str.substr(0, p0);
-
-        // COMMAND[ arguments)
-        str = str.substr(p0+1);
-        p1  = str.find_first_of(' ');
-    }
-
-    // String is of the form: COMMAND[ arguments]
-
-    // COMMAND
-    v[1] = str.substr(0, p1);
-
-    // Has arguments
-    if (p1!=string::npos)
-        v[2] = str.substr(p1+1);
-
-    return v;
-}
-*/
Index: trunk/FACT++/src/tools.h
===================================================================
--- trunk/FACT++/src/tools.h	(revision 11228)
+++ trunk/FACT++/src/tools.h	(revision 11229)
@@ -1,9 +1,8 @@
 #include <string>
-#include <vector>
 
 namespace Tools
 {
-//    std::string Format(const char *fmt, va_list &ap);
-//    std::string Form(const char *fmt, ...);
+    std::string Format(const char *fmt, va_list &ap);
+    std::string Form(const char *fmt, ...);
     std::string Trim(const std::string &str);
 }